 //
// jMax
// Copyright (C) 1994, 1995, 1998, 1999 by IRCAM-Centre Georges Pompidou, Paris, France.
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// See file LICENSE for further informations on licensing terms.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Based on Max/ISPW by Miller Puckette.
//
// Authors: Maurizio De Cecco, Francois Dechelle, Enzo Maggi, Norbert Schnell.
// 

package ircam.jmax.guiobj;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.event.*;

import ircam.jmax.*;
import ircam.jmax.fts.*;
import ircam.jmax.mda.*;
import ircam.jmax.dialogs.*;
import ircam.jmax.utils.*;

import ircam.jmax.editors.patcher.*;
import ircam.jmax.editors.patcher.objects.*;
import ircam.jmax.editors.patcher.actions.*;

import ircam.jmax.toolkit.*;
import ircam.jmax.toolkit.menus.*;
import ircam.jmax.toolkit.actions.*;

/** Implement the patcher editor File Menu */

public class ColorPopUpMenu extends JMenu
{
    static private ColorPopUpMenu colorPopup = new ColorPopUpMenu();

    private Color colors[] = 
    {
	Color.yellow,
	Color.blue,
	Color.cyan,
	Color.green,
	Color.magenta,
	Color.orange,
	Color.pink,
	Color.red,
	Color.white,
	Color.black
    };

    private String colorNames[] = 
    {
	"yellow",
	"blue",
	"cyan",
	"green",
	"magenta",
	"orange",
	"pink",
	"red",
	"white",
	"black"
    };

    public ColorPopUpMenu()
    {
	super("Colors");
	
	JMenuItem item;
	for (int i = 0; i < colorNames.length; i++)
	    {
		item = new JMenuItem(colorNames[i]);
		item.setBackground(colors[i]);
		item.setForeground(colors[i]);
		item.setFocusPainted(false);
		item.addActionListener(new SetObjectColorAction());
		add(item);
	    }
	
    }

    public static int getColorIndex(String name)
    {
	for (int i = 0; i < colorPopup.colorNames.length; i++)
	    {
		if(colorPopup.colorNames[i].equals(name))
		    return i;
	    }
	return -1;
    }
    
    public static Color getColorByIndex(int index)
    {
	if(index > colorPopup.colors.length)
	    return Color.yellow;
	else
	    return colorPopup.colors[index - 1];
    }

    public static ColorPopUpMenu getInstance()
    {
	return colorPopup;
    }
      
    public class SetObjectColorAction extends EditorAction
    {
	String color;
	public void actionPerformed(ActionEvent e)
	{
	    color = ((JMenuItem)e.getSource()).getText();
	    super.actionPerformed(e);
	}

	public void doAction(EditorContainer container)
	{
	    ((GraphicObject)ObjectPopUp.getPopUpTarget())
		.setColor(ColorPopUpMenu.getColorIndex(color)+1);
	}
    }
}






