;;
;; help patch declarations for the ispw standard signal classes
;;

;; arithmetics (6)
(help-patch "*~" (file-cat dir "help" "signal" "arith~.help.jmax"))
(help-patch "+~" (file-cat dir "help" "signal" "arith~.help.jmax"))
(help-patch "-~" (file-cat dir "help" "signal" "arith~.help.jmax"))
(help-patch "/~" (file-cat dir "help" "signal" "arith~.help.jmax"))
(help-patch "inv*~" (file-cat dir "help" "signal" "arith~.help.jmax"))
(help-patch "inv+~" (file-cat dir "help" "signal" "arith~.help.jmax"))

;; filters (5)
(help-patch "2p2z~" (file-cat dir "help" "signal" "2p2z~.help.jmax"))
(help-patch "2pole~" (file-cat dir "help" "signal" "2pole~.help.jmax"))
(help-patch "biquad~" (file-cat dir "help" "signal" "biquad~.help.jmax"))
(help-patch "wahwah~" (file-cat dir "help" "signal" "wahwah~.help.jmax"))
(help-patch "samphold~" (file-cat dir "help" "signal" "samphold~.help.jmax"))

;; trigonometrics and logarithms (10)
(help-patch "sin~" (file-cat dir "help" "signal" "trigon~.help.jmax"))
(help-patch "cos~" (file-cat dir "help" "signal" "trigon~.help.jmax"))
(help-patch "tan~" (file-cat dir "help" "signal" "trigon~.help.jmax"))
(help-patch "asin~" (file-cat dir "help" "signal" "trigon~.help.jmax"))
(help-patch "acos~" (file-cat dir "help" "signal" "trigon~.help.jmax"))
(help-patch "atan~" (file-cat dir "help" "signal" "trigon~.help.jmax"))
(help-patch "arctan2~" (file-cat dir "help" "signal" "arctan2~.help.jmax"))
(help-patch "sinh~" (file-cat dir "help" "signal" "trigon~.help.jmax"))
(help-patch "cosh~" (file-cat dir "help" "signal" "trigon~.help.jmax"))
(help-patch "tanh~" (file-cat dir "help" "signal" "trigon~.help.jmax"))

;; io (5)
(help-patch "adc~" (file-cat dir "help" "signal" "adc~.help.jmax"))
(help-patch "dac~" (file-cat dir "help" "signal" "adc~.help.jmax"))
(help-patch "readsf~" (file-cat dir "help" "signal" "sf~.help.jmax"))
(help-patch "writesf~" (file-cat dir "help" "signal" "sf~.help.jmax"))
(help-patch "print~" (file-cat dir "help" "signal" "print~.help.jmax"))

;; misc math (7)
(help-patch "abs~" (file-cat dir "help" "signal" "abs~.help.jmax"))
(help-patch "clip~" (file-cat dir "help" "signal" "clip~.help.jmax"))
(help-patch "exp~" (file-cat dir "help" "signal" "exp~.help.jmax"))
(help-patch "log10~" (file-cat dir "help" "signal" "exp~.help.jmax"))
(help-patch "log~" (file-cat dir "help" "signal" "exp~.help.jmax"))
(help-patch "rsqrt~" (file-cat dir "help" "signal" "sqrt~.help.jmax"))
(help-patch "sqrt~" (file-cat dir "help" "signal" "sqrt~.help.jmax"))

;; signal flow (6)
(help-patch "down~" (file-cat dir "help" "signal" "down~.help.jmax"))
(help-patch "up~" (file-cat dir "help" "signal" "down~.help.jmax"))
(help-patch "throw~" (file-cat dir "help" "signal" "catch~.help.jmax"))
(help-patch "catch~" (file-cat dir "help" "signal" "catch~.help.jmax"))
(help-patch "switch~" (file-cat dir "help" "signal" "switch~.help.jmax"))
(help-patch "thru~" (file-cat dir "help" "signal" "thru~.help.jmax"))

;; sampling (7)
(help-patch "table~" (file-cat dir "help" "signal" "table~.help.jmax"))
(help-patch "samppeek~" (file-cat dir "help" "signal" "samppeek~.help.jmax"))
(help-patch "sampread~" (file-cat dir "help" "signal" "sampwrite~.help.jmax"))
(help-patch "sampwrite~" (file-cat dir "help" "signal" "sampwrite~.help.jmax"))
(help-patch "tabcycle~" (file-cat dir "help" "signal" "tabcycle~.help.jmax"))
(help-patch "tabpeek~" (file-cat dir "help" "signal" "tabpeek~.help.jmax"))
(help-patch "tabpoke" (file-cat dir "help" "signal" "tabpoke.help.jmax"))

;; delay lines (3)
(help-patch "delwrite~" (file-cat dir "help" "signal" "delay~.help.jmax"))
(help-patch "delread~" (file-cat dir "help" "signal" "delay~.help.jmax"))
(help-patch "vd~" (file-cat dir "help" "signal" "delay~.help.jmax"))

;; fourier transformation (2)
(help-patch "fft~" (file-cat dir "help" "signal" "fft~.help.jmax"))
(help-patch "ifft~" (file-cat dir "help" "signal" "fft~.help.jmax"))

;; generators (5)
(help-patch "sig~" (file-cat dir "help" "signal" "sig~.help.jmax"))
(help-patch "line~" (file-cat dir "help" "signal" "line~.help.jmax"))
(help-patch "phasor~" (file-cat dir "help" "signal" "phasor~.help.jmax"))
(help-patch "osc1~" (file-cat dir "help" "signal" "osc1~.help.jmax"))
(help-patch "tab1~" (file-cat dir "help" "signal" "osc1~.help.jmax"))
(help-patch "noise~" (file-cat dir "help" "signal" "noise~.help.jmax"))

;; signal peep (7)
(help-patch "pitch~" (file-cat dir "help" "signal" "pitch~.help.jmax"))
(help-patch "pt~" (file-cat dir "help" "signal" "pt~.help.jmax"))
(help-patch "snapshot~" (file-cat dir "help" "signal" "snapshot~.help.jmax"))
(help-patch "threshold~" (file-cat dir "help" "signal" "threshold~.help.jmax"))
(help-patch "zerocross~" (file-cat dir "help" "signal" "zerocross~.help.jmax"))
(help-patch "samplerate~" (file-cat dir "help" "signal" "samplerate~.help.jmax"))
(help-patch "vectorsize~" (file-cat dir "help" "signal" "samplerate~.help.jmax"))

;; Summary
(help-summary "ISPW signal" (file-cat dir "help" "signal" "ispw.signal.summary.jmax"))
